<?php

if(!defined('VALID_CMS')) { die('ACCESS DENIED'); }

class cms_model_sitemap 
{
	private $site_domain = 'mysite.ru';
	
	protected static $instance;
	
    public static function getInstance() 
    {
        if (self::$instance === null) {
            self::$instance = new self;
        }
        return self::$instance;
    }
	
	public function getSiteMap()
	{
		$xml = new DomDocument('1.0','utf-8');
		define('DATE_FORMAT_RFC822','r');
		
		$urlset = $xml->appendChild($xml->createElement('urlset'));
		$urlset->setAttribute('xmlns:xsi','http://www.w3.org/2001/XMLSchema-instance');
		$urlset->setAttribute('xsi:schemaLocation','http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd');
		$urlset->setAttribute('xmlns','http://www.sitemaps.org/schemas/sitemap/0.9');
		
		$inDB = cmsDatabase::getInstance();
		
		$sql = "SELECT pubdate, title, seolink FROM cms_content ORDER BY pubdate DESC";
		
		$result = $inDB->query($sql);
		
		if ($inDB->num_rows($result)) {
			while ($item = $inDB->fetch_assoc($result)) {
				$lastmod_value = substr($item['pubdate'],0,10);
				$url = $urlset->appendChild($xml->createElement('url'));
				$loc = $url->appendChild($xml->createElement('loc'));
				$lastmod = $url->appendChild($xml->createElement('lastmod'));
				$changefreq = $url->appendChild($xml->createElement('changefreq'));
				$loc->appendChild($xml->createTextNode('http://' . $this->site_domain . '/'.$item['seolink'].'.html'));
				$lastmod->appendChild($xml->createTextNode($lastmod_value));
				$changefreq->appendChild($xml->createTextNode('never'));
			}
		}
		
		$xml->formatOutput = true;
		$xml->save(PATH.'/sitemap.xml');
	}
	
}
?>
